<template>
  <div
    class="d-flex flex-column"
    :style="{'max-width': '620px'}"
  >
    <b-form
      class="justify-content-between mb-1"
      inline
    >
      <b-form-radio-group
        v-model="alertSelectorFormat"
        v-b-tooltip.hover.v-primary
        :options="alertSelectorFormatOptions"
        title="Choose key to select alert thumbnails by"
        button-variant="outline-dark"
        buttons
        class="mr-1"
      />
      <b-form-select
        v-model="selected"
        :options="options"
        class="flex-fill mr-1"
      />
      <b-button-group class="mr-1">
        <div
          v-b-tooltip.hover.v-primary
          title="Display previous thumbnail"
        >
          <b-button
            :disabled="isFirst"
            variant="outline-dark"
            @click="gotoPrev"
          >
            <font-awesome-icon icon="chevron-left" />
          </b-button>
        </div>
        <div
          v-b-tooltip.hover.v-primary
          title="Display next thumbnail"
        >
          <b-button
            :disabled="isLast"
            variant="outline-dark"
            @click="gotoNext"
          >
            <font-awesome-icon icon="chevron-right" />
          </b-button>
        </div>
      </b-button-group>
      <b-button
        v-b-tooltip.hover.v-primary
        class="mr-1"
        title="Toggle invert image"
        variant="outline-dark"
        @click="inverse = !inverse"
      >
        <font-awesome-icon icon="adjust" />
      </b-button>
      <span
        v-b-tooltip.hover.v-primary
        title="We vertically flip thumbnails from ZTF for display.
          Thumbnails newer than 2022-02-13 are scaled to maximize feature resolution."
      >
        <font-awesome-icon icon="question-circle" />
      </span>
    </b-form>
    <alert-thumbnail-viewer
      v-if="selected"
      :alert-id="selected.id"
      :gap="'10px'"
      :inverse="inverse"
      :thumbnail-width="'200px'"
    />
  </div>
</template>

<script lang="ts">
import Vue, { PropOptions } from 'vue';

import AlertThumbnailViewer from '@/components/AlertThumbnailViewer.vue';
import { Alert } from '@/common/types';

/* eslint-disable-next-line no-shadow */
enum AlertSelectorFormat {
  MJD = 'MJD',
  UTC = 'UTC',
  ID = 'ID',
}

export default Vue.extend({
  components: {
    AlertThumbnailViewer,
  },

  props: {
    alerts: {
      type: Array,
      required: true,
    } as PropOptions<Alert[]>,
  },

  data() {
    return {
      AlertSelectorFormat,
      inverse: false,
      selected: null as Alert | null,
      alertSelectorFormat: AlertSelectorFormat.UTC,
      alertSelectorFormatOptions: [
        { text: 'UTC', value: AlertSelectorFormat.UTC },
        { text: 'MJD', value: AlertSelectorFormat.MJD },
        { text: 'ID', value: AlertSelectorFormat.ID },
      ],
    };
  },

  computed: {
    options(): { [key: string]: any }[] {
      return this.alerts.map((alert: Alert) => ({
        value: alert,
        text: this.formatAlert(alert),
      }));
    },

    isFirst(): boolean {
      return this.selected === this.alerts[0];
    },

    isLast(): boolean {
      return this.selected === this.alerts[this.alerts.length - 1];
    },

    next(): Alert | null {
      if (this.selected) {
        const index = this.alerts.findIndex((a) => a === this.selected);
        if (index !== -1) {
          return this.alerts[index + 1];
        }
      }
      return null;
    },

    prev(): Alert | null {
      if (this.selected) {
        const index = this.alerts.findIndex((a) => a === this.selected);
        if (index !== -1) {
          return this.alerts[index - 1];
        }
      }
      return null;
    },
  },

  watch: {
    alerts() {
      this.selected = this.alerts[this.alerts.length - 1];
    },
  },

  mounted() {
    this.selected = this.alerts[this.alerts.length - 1];
  },

  methods: {
    formatAlert(alert: Alert) {
      if (this.alertSelectorFormat === AlertSelectorFormat.UTC) {
        const date = (<any> this).mjdToDate(alert.mjd);
        return date.toISOString();
      } if (this.alertSelectorFormat === AlertSelectorFormat.MJD) {
        return alert.mjd.toFixed(2);
      }
      return alert.id;
    },
    gotoNext() {
      this.selected = this.next;
    },
    gotoPrev() {
      this.selected = this.prev;
    },
  },
});
</script>

<style scoped>
.viewer {
  display: flex;
  gap: 0.5em;
}
</style>
